#ifdef ASM
void mata_tela (void) {

  asm     numbytes EQU (80*2)*25

  asm     jmp  inicio

  asm     tela      db  numbytes DUP (0)
  asm     telavazia db  1

inicio:
  asm	  call pegatela
volte:
  asm     call dectela
  asm	  call poetela
  asm	  cmp  telavazia,1
  asm	  jne  volte
  asm	  jmp  fim

  asm     pegatela PROC NEAR
  asm     push CX
  asm     push DS   
  asm     push AX
  asm     push SI
  asm     push DI
  asm	  mov  CX,(80*25)
  asm	  mov  AX,0B800h
  asm	  mov  DS,AX
  asm	  mov  SI,0
  asm	  lea  DI,tela
  asm	  cld
  asm	  rep  movsw
  asm	  pop  DI
  asm     pop  SI
  asm     pop  AX
  asm     pop  DS
  asm     pop  CX
  asm	  ret
  asm pegatela ENDP

  asm dectela PROC NEAR
  asm     push SI
  asm     push CX
  asm     push AX
  asm	  lea  SI,tela
  asm	  mov  CX,(80*25)
  asm	  mov  telavazia,1
proxcaract:
  asm     mov  AL,[SI]
  asm	  cmp  AL,32
  asm	  ja   decrementa
  asm	  mov  byte ptr [SI],32
  asm	  jmp  pula
decrementa:
  asm     sub  byte ptr [SI],4
  asm	  mov  telavazia,0
pula:
  asm     mov  byte ptr [SI+1],07
  asm     add  SI,2
  asm	  dec  CX
  asm	  jcxz sai
  asm	  jmp proxcaract
sai:
  asm     pop  AX
  asm     pop  CX
  asm     pop  SI
  asm     ret
  asm dectela ENDP

  asm poetela PROC NEAR
  asm     push AX
  asm	  push ES
  asm     push DI
  asm     push SI
  asm     push CX
  asm	  mov  AX,0B800h
  asm	  mov  ES,AX
  asm	  mov  DI,0
  asm	  lea  SI,tela
  asm	  mov  CX,(80*25)
  asm	  cld
  asm	  rep  movsw
  asm     pop  CX
  asm     pop  SI
  asm     pop  DI
  asm     pop  ES
  asm     pop  AX
  asm 	  ret
  asm poetela ENDP
  
fim:
;
}

void tira_tela (void)
{

asm       JMP  inicio
asm       colunas db 1 DUP (0)
inicio:
asm       inc  colunas
asm       cmp  colunas,80
asm       jne  mover
asm       jmp  fim
mover:
asm       push BX
asm       push AX
asm       push SI
asm       push ES
asm       push DS
asm       push DX
asm       push DI
asm       mov  BL,0
retorne:
asm       mov  AX,80*2
asm       mul  BL
asm       mov  SI,AX
asm       mov  AX,0B800h
asm       mov  DS,AX
asm       mov  DX,word ptr [SI]
asm       mov  ES,AX
asm       mov  DI,SI
asm       add  SI,2
asm       mov  CX,79
asm       cld
asm       rep  movsw
asm       inc  BL
asm       cmp  BL,25
asm       jne  retorne
asm       pop  DI
asm       pop  DX
asm       pop  DS
asm       pop  ES
asm       pop  SI
asm       pop  AX
asm       pop  BX
asm       jmp  inicio

fim:
;
}
#endif