#include "pacienc.h"
#include <conio.h>

void poe_carta_baralho (void)
{
  int passada=0;
  do {
    carta_mesa++;
    if (carta_mesa==52) {
      passada++;
      if (passada==2) {
	carta_mesa=-1;
	break;
      }
      carta_mesa=0;
    }
  } while (!strcmp (baralho[carta_mesa].simbolo, "XX"));

  if (carta_mesa!=-1) {
    gotoxy (13, 16);
    cprintf ("ͻ");
    gotoxy (13, 17);
    cprintf ("");
    if (baralho[carta_mesa].naipe==espadas ||
	baralho[carta_mesa].naipe==paus) {
      textbackground (BLUE);
      textcolor (YELLOW);
    } else {
      textbackground (GREEN);
      textcolor (YELLOW);
    }
    cprintf ("%2s ",baralho[carta_mesa].simbolo);
    switch (baralho[carta_mesa].naipe) {
      case (paus):
	cprintf ("%c",5);
	break;
      case (ouro):
	cprintf ("%c",4);
	break;
      case (espadas):
	cprintf ("%c",6);
	break;
      case (copas):
	cprintf ("%c",3);
	break;
    }
    cprintf (" ");
    textbackground (BLACK);
    textcolor (WHITE);
    cprintf ("");
    gotoxy (13, 18);
    cprintf ("ͼ");
  }
  else {
    int coluna;

    for (coluna=15; coluna<18; coluna++) {
      gotoxy (12, coluna);
      cprintf (" ");
    gotoxy (12, 18);
    cprintf ("        ");
    }
  }
}

void baralho_mesa (int fila)
{

  if (mesa[fila][topo_mesa[fila]].posicao==visivel && topo_mesa[fila]!=-1) {
    if (baralho[carta_mesa].indice==mesa[fila][topo_mesa[fila]].indice-1) {
      int cor_mesa,
	  cor_baralho;

      if (mesa[fila][topo_mesa[fila]].naipe==paus ||
          mesa[fila][topo_mesa[fila]].naipe==espadas)
	cor_mesa=reverso;
      else
	cor_mesa=normal;
      if (baralho[carta_mesa].naipe==paus ||
	  baralho[carta_mesa].naipe==espadas)
	cor_baralho=reverso;
      else
	cor_baralho=normal;
      if (cor_mesa!=cor_baralho) {
	int posicao_mesa=++topo_mesa[fila];
	strcpy (mesa[fila][posicao_mesa].simbolo,
		baralho[carta_mesa].simbolo);
	mesa[fila][posicao_mesa].naipe=baralho[carta_mesa].naipe;
	mesa[fila][posicao_mesa].indice=baralho[carta_mesa].indice;
	mesa[fila][posicao_mesa].posicao=visivel;
	strcpy (baralho[carta_mesa].simbolo, "XX");
	reconstroi_fila (fila);
	poe_carta_baralho ();
      }
    }
    else
      movimento_ilegal ();
    }
  if (topo_mesa[fila]==-1)
    if (baralho[carta_mesa].indice==12) {
      strcpy (mesa[fila][++topo_mesa[fila]].simbolo,
	      baralho[carta_mesa].simbolo);
      mesa[fila][topo_mesa[fila]].naipe=baralho[carta_mesa].naipe;
      mesa[fila][topo_mesa[fila]].indice=baralho[carta_mesa].indice;
      mesa[fila][topo_mesa[fila]].posicao=visivel;
      strcpy (baralho[carta_mesa].simbolo, "XX");
      reconstroi_fila (fila);
      poe_carta_baralho ();
    }
    else
      movimento_ilegal ();
}

void baralho_monte (void)
{
  int monte_destino=baralho[carta_mesa].naipe;

  if (baralho[carta_mesa].indice==topo_monte[monte_destino]+1) {
    int coluna_monte=++topo_monte[monte_destino];
    strcpy (monte[monte_destino][coluna_monte].simbolo,
	    baralho[carta_mesa].simbolo);
    monte[monte_destino][coluna_monte].naipe=baralho[carta_mesa].naipe;
    monte[monte_destino][coluna_monte].indice=baralho[carta_mesa].indice;
    monte[monte_destino][coluna_monte].posicao=visivel;
    strcpy (baralho[carta_mesa].simbolo, "XX");
    monta_monte ();
    poe_carta_baralho ();
  }
  else
    movimento_ilegal ();
}

void mesa_para_monte (int fila)
{
  int monte_destino=mesa[fila][topo_mesa[fila]].naipe;

  if (mesa[fila][topo_mesa[fila]].indice == topo_monte[monte_destino]+1) {
    strcpy (monte[monte_destino][++topo_monte[monte_destino]].simbolo,
	    mesa[fila][topo_mesa[fila]].simbolo);
    monte[monte_destino][topo_monte[monte_destino]].naipe=
      mesa[fila][topo_mesa[fila]].naipe;
    monte[monte_destino][topo_monte[monte_destino]].indice=
      mesa[fila][topo_mesa[fila]].indice;
    monte[monte_destino][topo_monte[monte_destino]].posicao=visivel;
    --topo_mesa[fila];
    reconstroi_fila (fila);
    monta_monte ();
  }
  else
    movimento_ilegal ();
}

void monte_para_mesa (int fila)
{
  int cor_mesa,
      monte_fonte=-1;

  if (mesa[fila][topo_mesa[fila]].naipe==paus ||
      mesa[fila][topo_mesa[fila]].naipe==espadas)
    cor_mesa=reverso;
  else
    cor_mesa=normal;
  if (cor_mesa==reverso) {
    if (monte[copas][topo_monte[copas]].indice ==
	mesa[fila][topo_mesa[fila]].indice-1 && topo_monte[copas]!=-1)
      monte_fonte=copas;
    else
      if (monte[ouro][topo_monte[ouro]].indice ==
	  mesa[fila][topo_mesa[fila]].indice-1 && topo_monte[ouro]!=-1)
	monte_fonte=ouro;
  }
  else {
    if (monte[paus][topo_monte[paus]].indice ==
	mesa[fila][topo_mesa[fila]].indice-1  && topo_monte[paus]!=-1)
      monte_fonte=paus;
    else
      if (monte[espadas][topo_monte[espadas]].indice ==
	  mesa[fila][topo_mesa[fila]].indice-1 && topo_monte[espadas]!=-1)
	monte_fonte=espadas;
  }
  if (monte_fonte!=-1) {
    strcpy (mesa[fila][++topo_mesa[fila]].simbolo,
	    monte[monte_fonte][topo_monte[monte_fonte]].simbolo);
    mesa[fila][topo_mesa[fila]].naipe=
      monte[monte_fonte][topo_monte[monte_fonte]].naipe;
    mesa[fila][topo_mesa[fila]].indice=
      monte[monte_fonte][topo_monte[monte_fonte]].indice;
    mesa[fila][topo_mesa[fila]].posicao=visivel;
    --topo_monte[monte_fonte];
    monta_monte ();
    reconstroi_fila (fila);
  }
  else
    movimento_ilegal ();
}

void mesa_mesa (int fonte, int destino)
{
  int item_destino=topo_mesa[destino],
      item_fonte=topo_mesa[fonte],
      indice_destino=mesa[destino][item_destino].indice-1,
      cor_mesa,
      modificacao=0;

  if (fonte==destino) {
    if (mesa[fonte][item_fonte].posicao==nao_visivel) {
      mesa[fonte][item_fonte].posicao=visivel;
      reconstroi_fila (fonte);
    }
  }
  else {
    if (topo_mesa[destino]==-1) {
      int contador=item_fonte,
	  posicao=0,
	  quantidade,
	  valido=0;

      do {
	if (mesa[fonte][contador].indice==12 &&
	    mesa[fonte][contador].posicao==visivel) {
	  valido=1;
	  break;
	}
	++posicao;
	--contador;
      } while (contador!=-1);
      quantidade=posicao;
      contador=item_fonte;
      if (valido) {
	do {
	  strcpy (mesa[destino][posicao].simbolo,
	  mesa[fonte][contador].simbolo);
	  mesa[destino][posicao].naipe=
	    mesa[fonte][contador].naipe;
	  mesa[destino][posicao].indice=
	    mesa[fonte][contador].indice;
	  mesa[destino][posicao].posicao=visivel;
	  --posicao;
	  --contador;
	} while (mesa[fonte][contador+1].indice!=12);
	topo_mesa[fonte]=contador;
	topo_mesa[destino]=quantidade;
	reconstroi_fila (fonte);
	reconstroi_fila (destino);
	modificacao=1;
      }
    }
    else {
      if (mesa[destino][item_destino].naipe==paus ||
	  mesa[destino][item_destino].naipe==espadas)
	cor_mesa=reverso;
      else
	cor_mesa=normal;
      while (mesa[fonte][item_fonte].posicao==visivel &&
	     item_fonte!=-1) {
	int cor_carta;

	if (mesa[fonte][item_fonte].naipe==paus ||
	    mesa[fonte][item_fonte].naipe==espadas)
	  cor_carta=reverso;
	else
	  cor_carta=normal;
	if (cor_mesa!=cor_carta &&
	    mesa[fonte][item_fonte].indice==indice_destino) {
	  int contador;

	  modificacao=1;
	  for (contador=item_fonte; contador<=topo_mesa[fonte]; contador++) {
	    strcpy (mesa[destino][++topo_mesa[destino]].simbolo,
	    mesa[fonte][contador].simbolo);
	    mesa[destino][topo_mesa[destino]].naipe=
	      mesa[fonte][contador].naipe;
	    mesa[destino][topo_mesa[destino]].indice=
	      mesa[fonte][contador].indice;
	    mesa[destino][topo_mesa[destino]].posicao=visivel;
	  }
	  topo_mesa[fonte]=item_fonte-1;
	  reconstroi_fila (fonte);
	  reconstroi_fila (destino);
	  break;
	}
	else
	  --item_fonte;
      }
    }
    if (modificacao==0)
      movimento_ilegal ();
  }
}
