#include <conio.h>
#include "pacienc.h"

void tela_apresentacao (void)
{
  int coluna[8],
      valor_incremento [8],
      contador;

  char nome[23];

  nome[17]='.';
  nome[05]='s';
  nome[19]='C';
  nome[00]='C';
  clrscr ();
  nome[1]='a';
  nome[7]='F';
  nome[13]='d';
  nome[22]='z';
  nome[15]=' ';
  gotoxy (5, 22);
  nome[4]='o';
  nome[3]='l';
  nome[14]='o';
  textcolor (WHITE+BLINK);
  nome[16]='B';
  nome[11]='a';
  textcolor (GREEN);
  cprintf ("Pressione qualquer tecla para comear");
  nome[06]=' ';
  nome[18]=' ';
  nome[21]='u';
  textcolor (WHITE);
  nome[2]='r';
  nome[10]='n';
  nome[8]='e';
  gotoxy (5, 20);
  nome[10]='n';
  nome[12]='n';
  for (contador=0; contador<8; contador++) {
    valor_incremento[contador]=-1;
    coluna[contador]=3+contador;
  }
  nome[12]='n';
  nome[20]='r';
  nome[9]='r';
  gotoxy (5,24);
  cprintf ("Autor:");
  for (contador=0; contador<23; contador++) {
    gotoxy (12+contador, 24);
    cprintf ("%c",nome[contador]);
  }
  textcolor (RED);
  do {
    gotoxy (coluna[0]+33, 3);
    cprintf
    ("  ");
    gotoxy (coluna[1]+32, 4);
    cprintf
    ("   ");
    gotoxy (coluna[2], 6);
    cprintf ("         ");
    gotoxy (coluna[2]+34, 6);
    cprintf ("            ");
    gotoxy (coluna[3], 7);
    cprintf ("                     ");
    gotoxy (coluna[3]+39, 7);
    cprintf ("                     ");
    gotoxy (coluna[4], 8);
    cprintf ("                    ");
    gotoxy (coluna[4]+32, 8);
    cprintf ("                       ");
    gotoxy (coluna[5], 9);
    cprintf ("              ");
    gotoxy (coluna[5]+32, 9);
    cprintf ("               ");
    gotoxy (coluna[6], 10);
    cprintf ("                      ");
    gotoxy (coluna[6]+32, 10);
    cprintf ("                        ");
    gotoxy (coluna[7], 11);
    cprintf ("                 ");
    gotoxy (coluna[7]+32, 11);
    cprintf ("                ");
    for (contador=0; contador<8; contador++) {
      coluna [contador]+=valor_incremento[contador];
      if (coluna[contador]==2 || coluna[contador]==10)
	valor_incremento[contador]=-valor_incremento[contador];
    }
  } while (!bioskey (1));
  textcolor (WHITE);
  getch ();
  gotoxy (1,1);
#ifdef ASM
  tira_tela ();
#else
  clrscr ();
#endif
}

void limpa_mesa (void)
{
  int fila,
      coluna;

  for (fila=0; fila<7; fila++) {
    topo_mesa[fila]=fila;
    for (coluna=0; coluna<20; coluna++)
      strcpy (mesa[fila][coluna].simbolo, "XX");
  }
  for (coluna=0; coluna<4; coluna++)
    topo_monte [coluna]=-1;
}

void monta_monte (void)
{
  int contador,
      coluna,
      linha;
  for (contador=0; contador<4; contador++) {
    switch (contador) {
      case (paus):
	coluna=8;
	linha=2;
	break;
      case (copas):
	coluna=16;
	linha=2;
	break;
      case (espadas):
	coluna=8;
	linha=6;
	break;
      case (ouro):
	coluna=16;
	linha=6;
	break;
    }
    if (topo_monte[contador]==-1) {
      int incremento;
      for (incremento=0; incremento<3; incremento++) {
	gotoxy (coluna, linha+incremento);
	cprintf ("");
      }
    }
    else {
      gotoxy (coluna, linha);
      cprintf ("ͻ");
      gotoxy (coluna, linha+1);
      cprintf ("");
      if (monte[contador][topo_monte[contador]].naipe==espadas ||
	  monte[contador][topo_monte[contador]].naipe==paus) {
	textbackground (BLUE);
	textcolor (YELLOW);
      } else {
	textbackground (GREEN);
	textcolor (YELLOW);
      }
      cprintf ("%2s ",monte[contador][topo_monte[contador]].simbolo);
      switch (monte[contador][topo_monte[contador]].naipe) {
	case (paus):
	  cprintf ("%c",5);
	  break;
	case (ouro):
	  cprintf ("%c",4);
	  break;
	case (espadas):
	  cprintf ("%c",6);
	  break;
	case (copas):
	  cprintf ("%c",3);
	  break;
      }
      cprintf (" ");
      textbackground (BLACK);
      textcolor (WHITE);
      cprintf ("");
      gotoxy (coluna, linha+2);
      cprintf ("ͼ");
    }
  }
}

void distribui_cartas (void)
{
  int fila,
      coluna,
      vez_baralho=0;

  for (fila=6; fila>-1; fila--) {
    baralho[vez_baralho].posicao=visivel;
    for (coluna=fila; coluna>-1; coluna--) {
      strcpy (mesa[fila][coluna].simbolo, baralho[vez_baralho].simbolo);
      mesa[fila][coluna].naipe=baralho[vez_baralho].naipe;
      mesa[fila][coluna].indice=baralho[vez_baralho].indice;
      mesa[fila][coluna].posicao=baralho[vez_baralho].posicao;
      strcpy(baralho[vez_baralho].simbolo, "XX");
      vez_baralho++;

      textbackground (BLACK);
      textcolor (WHITE);
      gotoxy (fila*7+31, coluna*2+2);
      cprintf ("ͻ");
      if (mesa[fila][coluna].posicao==nao_visivel) {
	gotoxy (fila*7+31, coluna*2+3);
	cprintf ("");
      }
      else {
	gotoxy (fila*7+31, coluna*2+3);
	cprintf ("");
	if (mesa[fila][coluna].naipe==espadas ||
	    mesa[fila][coluna].naipe==paus) {
	  textbackground (BLUE);
	  textcolor (YELLOW);
	}
	else {
	  textbackground (GREEN);
	  textcolor (YELLOW);
	}
	cprintf ("%2s ",mesa[fila][coluna].simbolo);
	switch (mesa[fila][coluna].naipe) {
	  case (paus):
	    cprintf ("%c",5);
	    break;
	  case (ouro):
	    cprintf ("%c",4);
	    break;
	  case (espadas):
	    cprintf ("%c",6);
	    break;
	  case (copas):
	    cprintf ("%c",3);
	    break;
	}
	cprintf (" ");
	textbackground (BLACK);
	textcolor (WHITE);
	cprintf ("");
	gotoxy (fila*7+31, coluna*2+4);
	cprintf ("ͼ");
      }
    }
  }
  carta_mesa=vez_baralho;

  gotoxy (33, 1);
  cprintf ("[1]");
  gotoxy (40, 1);
  cprintf ("[2]");
  gotoxy (47, 1);
  cprintf ("[3]");
  gotoxy (54, 1);
  cprintf ("[4]");
  gotoxy (61, 1);
  cprintf ("[5]");
  gotoxy (68, 1);
  cprintf ("[6]");
  gotoxy (75, 1);
  cprintf ("[7]");
  monta_monte ();

  gotoxy (8, 1);
  cprintf ("[M]onte");
  for (coluna=15; coluna<18; coluna++) {
    gotoxy (12, coluna);
    cprintf ("");
  }
  gotoxy (7, 14);
  cprintf ("[Barra de Espaco]");
}
